<div id='root'></div>
<script src='https://unpkg.com/react@16/umd/react.development.js'></script>
<script src='https://unpkg.com/react-dom@16/umd/react-dom.development.js'></script>
<script src='https://unpkg.com/babel-standalone@6.26.0/babel.js'></script>
<style>
  button {
    border: 1px solid #ccc;
    background: #fff;
    font-size: 1em;
    padding: 15;
    margin: 5;
    width: 200;
  }

  label {
    font-size: 4em;
    display: block;
    text-align: center;
  }

  .container {
    display: flex;
    align-items: center;
    justify-content: center;
    height: 97vh;
  }
</style>
<script type='text/babel'>
  const root = document.getElementById('root')


  class StopWatch extends React.Component {
    state = {lapse: 0, running: false}
    
    handleRunClick = () => {
      this.setState(state => {
        if (state.running) {
          clearInterval(this.timer)
        } else {
          const startTime =  Date.now() - this.state.lapse
          this.timer = setInterval(() => {
            this.setState({ lapse: Date.now() - startTime })
          })
        }
        return { running: !state.running }
      })
    }

    handleClearClick = () => {
      clearInterval(this.timer)
      this.setState({lapse: 0, running: false})
    }

    render() {
      const {running, lapse} = this.state

      return (
        <div className='container'>
          <div>
            <label>
              {parseInt(lapse / 1000)} s
            </label>
            <button onClick={this.handleRunClick}>
              {running ? 'Detener': 'Iniciar'}
            </button>
            <button onClick={this.handleClearClick}>
              Limpiar
            </button>
          </div>
        </div>
      )
    }
  }


  ReactDOM.render(<StopWatch />, root)
</script>